# Create Contacts

> Source: https://truto.one/docs/api-reference/unified-crm-api/contacts/create/

`POST /unified/crm/contacts`

Resource: **Contacts** · API: **Unified CRM API**

## Supported integrations

Affinity, Attio, Capsule, Close, Copper, Microsoft Dynamics 365 Sales, Freshsales, Highlevel, HubSpot, Insightly, Keap, Monday CRM, Nutshell, OnePageCRM, Outreach, Pipedrive, Pipeliner, Planhat, Salesflare, Salesforce, Teamleader, Wix, Zendesk Sell, Zoho CRM

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`workspace`** _(object)_

## Request body

- **`first_name`** _(string)_
  The contact's first name
- **`last_name`** _(string)_
  The contact's last name
- **`email_addresses`** _(array<object>)_
  - **`id`** _(string)_
    The unique identifier of the email addresses
  - **`email`** _(string, required)_
    The email address
  - **`type`** _(string)_
    The email address type
- **`account`** _(object)_
  The account to be associated with this contact.
  - **`id`** _(string, required)_
    The unique identifier for the account.
  - **`name`** _(string)_
    The account's name
- **`name`** _(string)_
  The contact's full name
- **`title`** _(string)_
  The contact's job title
- **`phone_numbers`** _(array<object>)_
  - **`id`** _(string)_
    The unique identifier of the phone number
  - **`number`** _(string, required)_
    The phone number
  - **`type`** _(string)_
    The phone number type
    Allowed: `phone`, `mobile`, `fax`, `work`, `mobile`, `fax`, `phone`, `mobile`, `home`, `other`, `assistant`, `fax`
- **`custom_fields`** _(object)_
  Custom fields to be set on the contact. The custom_fields object will be a key-value pair, where the key will be the `name` attribute of the custom field found in the response of https://truto.one/docs/api-reference/unified-crm-api/fields/list endpoint.
- **`description`** _(unknown)_
- **`addresses`** _(array<object>)_
  - **`id`** _(string)_
    The unique identifier of the address
  - **`street_1`** _(string)_
    Line 1 of the street address
  - **`street_2`** _(string)_
    Line 2 of the street address
  - **`city`** _(string)_
    The city
  - **`state`** _(string)_
    The state
  - **`postal_code`** _(string)_
    The postal code
  - **`country`** _(string)_
    The country
  - **`type`** _(string)_
    The address type
- **`tags`** _(array<object>)_
  The contact's tags
  - **`id`** _(string)_
    The tag's unique identifier
  - **`name`** _(string)_
    The tag's name
- **`created_at`** _(string)_
  The date and time of the contact's creation
- **`owner`** _(object)_
  The account's owner
  - **`id`** _(string, required)_
    The owner's unique identifier
- **`job_title`** _(unknown)_
- **`phone_numbesr`** _(unknown)_
- **`phone_number`** _(unknown)_
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The contact's unique identifier
- **`first_name`** _(string)_
  The contact's first name
- **`last_name`** _(string)_
  The contact's last name
- **`name`** _(string)_
  The contact's full name
- **`title`** _(string)_
  The contact's job title
- **`account`** _(object)_
  The contact's account
  - **`id`** _(string)_
    The account's unique identifier
  - **`name`** _(string)_
    The account's name
- **`addresses`** _(array<object>)_
  - **`id`** _(string)_
    The unique identifier of the address
  - **`street_1`** _(string)_
    Line 1 of the street address
  - **`street_2`** _(string)_
    Line 2 of the street address
  - **`city`** _(string)_
    The city
  - **`state`** _(string)_
    The state
  - **`postal_code`** _(string)_
    The postal code
  - **`country`** _(string)_
    The country
  - **`type`** _(string)_
    The address type
- **`email_addresses`** _(array<object>)_
  - **`id`** _(string)_
    The unique identifier of the email addresses
  - **`email`** _(string)_
    The email address
  - **`type`** _(string)_
    The email address type
- **`phone_numbers`** _(array<object>)_
  - **`id`** _(string)_
    The unique identifier of the phone number
  - **`number`** _(string)_
    The phone number
  - **`extension`** _(string)_
    The extension of the phone number
  - **`type`** _(string)_
    The phone number type
- **`tags`** _(array<object>)_
  The contact's tags
  - **`id`** _(string)_
    The tag's unique identifier
  - **`name`** _(string)_
    The tag's name
- **`custom_fields`** _(object)_
  All the custom fields present on the contact
- **`last_activity_at`** _(string)_
  The date and time of the contact's last activity
- **`created_at`** _(string)_
  The date and time of the contact's creation
- **`updated_at`** _(string)_
  The date and time of the contact's last update
- **`etag`** _(string)_
  The unique identifier for the specific version of the resource.
- **`owner`** _(object)_
  The account's owner
  - **`id`** _(string)_
    The owner's unique identifier
- **`urls`** _(array<object>)_
  The contact's urls
  - **`url`** _(string)_
    The contact's URL
  - **`type`** _(string)_
    The contact's URL type
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X POST 'https://api.truto.one/unified/crm/contacts?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "first_name": "your_first_name",
  "last_name": "your_last_name",
  "email_addresses": [],
  "account": {},
  "name": "your_name",
  "title": "your_title",
  "phone_numbers": [],
  "custom_fields": "{\n  \"custom_field_name_1\": \"foo\",\n  \"custom_field_name_2\": \"bar\"\n}\n",
  "addresses": [],
  "tags": [],
  "created_at": "your_created_at",
  "owner": {},
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "first_name": "your_first_name",
  "last_name": "your_last_name",
  "email_addresses": [],
  "account": {},
  "name": "your_name",
  "title": "your_title",
  "phone_numbers": [],
  "custom_fields": "{\n  \"custom_field_name_1\": \"foo\",\n  \"custom_field_name_2\": \"bar\"\n}\n",
  "addresses": [],
  "tags": [],
  "created_at": "your_created_at",
  "owner": {},
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/crm/contacts?integrated_account_id=${integratedAccountId}`, {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/crm/contacts"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "first_name": "your_first_name",
    "last_name": "your_last_name",
    "email_addresses": [],
    "account": {},
    "name": "your_name",
    "title": "your_title",
    "phone_numbers": [],
    "custom_fields": "{\n  \"custom_field_name_1\": \"foo\",\n  \"custom_field_name_2\": \"bar\"\n}\n",
    "addresses": [],
    "tags": [],
    "created_at": "your_created_at",
    "owner": {},
    "remote_data": {}
}

response = requests.post(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.create(
  'crm',
  'contacts',
  {
  "first_name": "your_first_name",
  "last_name": "your_last_name",
  "email_addresses": [],
  "account": {},
  "name": "your_name",
  "title": "your_title",
  "phone_numbers": [],
  "custom_fields": "{\n  \"custom_field_name_1\": \"foo\",\n  \"custom_field_name_2\": \"bar\"\n}\n",
  "addresses": [],
  "tags": [],
  "created_at": "your_created_at",
  "owner": {},
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.create(
        "crm",
        "contacts",
        {
        "first_name": "your_first_name",
        "last_name": "your_last_name",
        "email_addresses": [],
        "account": {},
        "name": "your_name",
        "title": "your_title",
        "phone_numbers": [],
        "custom_fields": "{\n  \"custom_field_name_1\": \"foo\",\n  \"custom_field_name_2\": \"bar\"\n}\n",
        "addresses": [],
        "tags": [],
        "created_at": "your_created_at",
        "owner": {},
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
